
function  C2p29_PSET1_3
%%
% ********************************************************************
% Course Homework
%               2.29: Numerical Fluid Mechanincs, Spring 2007
% Problem Set #1, Problem #4
% 02/12/07
% ********************************************************************
% Reza Karimi:
%                            Graduate Student
%                    Mechanical Engineering Department
%                  Massachusetts Institute of Technology
% Email:  rkarimi@mit.edu
% Office: NE47-319, 500 Technology Square, Cambridge, MA 02139
% Phone: (617) 324-7605
% ********************************************************************



%%
close all,clear all,clc,warning off
format short


%% Part b)
n_max=10;

display('Part b)')
[V_y,Order,T_c]=All_Y2k(n_max);
Order,V_y
format long
T_c
%% Part c)
x=pi/4;
f_exact=sqrt(2);

fprintf('\n\nCase -- 2k ----- f ----------------------- relative error ----------------- absolute error  -------');

fprintf('\n\nx=pi/4 Exact Value of Double f=%.15f',f_exact);
fprintf('\nx=pi/4 Exact Value of Single f=%.7f',single(f_exact));
Term_Abs_Limit=eps('double');Sum_Abs_Limit=-1;
[f,order_c]=sec_ForwardSum(x,Term_Abs_Limit,Sum_Abs_Limit);
fprintf('\n\n c) \t%d\t%.15f\t%.15e\t\t%.15e\n',order_c,f,(f-f_exact)/f_exact,f-f_exact);  %It makes a difference for single between f/f_e-1 and (f-f_e)/f_e

%% Part d)
Term_Abs_Limit=0            ;Sum_Abs_Limit=-1;
[f,order_d]=sec_ForwardSum(x,Term_Abs_Limit,Sum_Abs_Limit);
fprintf(' d) \t%d\t%.15f\t%.15e\t\t%.15e\n',order_d,f,(f-f_exact)/f_exact,f-f_exact);

%% Part e)
Term_Abs_Limit=0            ;Sum_Abs_Limit=0 ;
[f,order_e]=sec_ForwardSum(x,Term_Abs_Limit,Sum_Abs_Limit);
fprintf(' e) \t%d\t%.15f\t%.15e\t\t%.15e\n',order_e,f,(f-f_exact)/f_exact,f-f_exact);


%% Part f)
Do_Single=1;
Term_Abs_Limit=eps('single');Sum_Abs_Limit=-1;
[f,order]=sec_ForwardSum(x,Term_Abs_Limit,Sum_Abs_Limit,Do_Single);
fprintf('f+c) \t%d\t%.7f\t\t%+.7e\t\t\t%+.7e\n',order,f,(f-f_exact)/f_exact,f-f_exact);   

Term_Abs_Limit=0            ;Sum_Abs_Limit=-1;
[f,order]=sec_ForwardSum(x,Term_Abs_Limit,Sum_Abs_Limit,Do_Single);
fprintf('f+d) \t%d\t%.7f\t\t%+.7e\t\t\t%+.7e\n',order,f,(f-f_exact)/f_exact,f-f_exact);

Term_Abs_Limit=0            ;Sum_Abs_Limit=0 ;
[f,order]=sec_ForwardSum(x,Term_Abs_Limit,Sum_Abs_Limit,Do_Single);
fprintf('f+e) \t%d\t%.7f\t\t%+.7e\t\t\t%+.7e\n',order,f,(f-f_exact)/f_exact,f-f_exact);

%% Part g)
[f]=sec_BackwardSum(x,order_c);
fprintf('g+c) \t%d\t%.15f\t%+.15e\t\t%+.15e\n',order_c,f,(f-f_exact)/f_exact,f-f_exact);
[f]=sec_BackwardSum(x,order_c+20);
fprintf('g+c) \t%d\t%.15f\t%+.15e\t\t%+.15e\n',order_c+20,f,(f-f_exact)/f_exact,f-f_exact);

[f]=sec_BackwardSum(x,order_d);
[f]=sec_BackwardSum(x,order_d);
fprintf('g+d) \t%d\t%.15f\t%+.15e\t\t%+.15e\n',order_d,f,(f-f_exact)/f_exact,f-f_exact);

[f]=sec_BackwardSum(x,order_e);
fprintf('g+e) \t%d\t%.15f\t%+.15e\t\t%+.15e\n',order_e,f,(f-f_exact)/f_exact,f-f_exact);

%% Part h)
Term_Abs_Limit=0            ;Sum_Abs_Limit=0 ;
[f,order]=sec_Inverse_COS(x,Term_Abs_Limit,Sum_Abs_Limit);
fprintf(' h) \t%d\t%.15f\t%.15e\t\t%.15e\n',order,f,(f-f_exact)/f_exact,f-f_exact);


%% Part j)
Term_Abs_Limit=0            ;Sum_Abs_Limit=0 ;

x=pi/8;
f_exact=2/(2+2^(1/2))^(1/2);
fprintf('\nx=pi/8 Exact Value of Double f=%.15f\n\n',f_exact);
[f,order]=sec_ForwardSum(x,Term_Abs_Limit,Sum_Abs_Limit);
fprintf('sec j) \t%d\t%.15f\t%+.15e\t\t%+.15e\n',order,f,(f-f_exact)/f_exact,f-f_exact);
[f,order]=sec_Inverse_COS(x,Term_Abs_Limit,Sum_Abs_Limit);
fprintf('cos j) \t%d\t%.15f\t%+.15e\t\t%+.15e\n',order,f,(f-f_exact)/f_exact,f-f_exact);

x=3*pi/8;
f_exact=(1-1/f_exact^2)^-.5;
fprintf('\nx=3pi/8 Exact Value of Double f=%.15f\n\n',f_exact);
[f,order]=sec_ForwardSum(x,Term_Abs_Limit,Sum_Abs_Limit);
fprintf('sec j) \t%d\t%.15f\t%+.15e\t\t%+.15e\n',order,f,(f-f_exact)/f_exact,f-f_exact);
[f,order]=sec_Inverse_COS(x,Term_Abs_Limit,Sum_Abs_Limit);
fprintf('cos j) \t%d\t%.15f\t%+.15e\t\t%+.15e\n',order,f,(f-f_exact)/f_exact,f-f_exact);

x=pi/16;
cos_pi_8=1/(2/(2+2^(1/2))^(1/2));
cos_pi_16=((1+cos_pi_8)/2)^.5;
f_exact=1/cos_pi_16;
fprintf('\nx=pi/16 Exact Value of Double f=%.15f\n\n',f_exact);
[f,order]=sec_ForwardSum(x,Term_Abs_Limit,Sum_Abs_Limit);
fprintf('sec j) \t%d\t%.15f\t%+.15e\t\t%+.15e\n',order,f,(f-f_exact)/f_exact,f-f_exact);
[f,order]=sec_Inverse_COS(x,Term_Abs_Limit,Sum_Abs_Limit);
fprintf('cos j) \t%d\t%.15f\t%+.15e\t\t%+.15e\n',order,f,(f-f_exact)/f_exact,f-f_exact);

x=7*pi/16;
f_exact=(1-1/f_exact^2)^-.5;
fprintf('\nx=7pi/16 Exact Value of Double f=%.15f\n\n',f_exact);
[f,order]=sec_ForwardSum(x,Term_Abs_Limit,Sum_Abs_Limit);
fprintf('sec j) \t%d\t%.15f\t%+.15e\t\t%+.15e\n',order,f,(f/f_exact-1),f-f_exact);
[f,order]=sec_Inverse_COS(x,Term_Abs_Limit,Sum_Abs_Limit);
fprintf('cos j) \t%d\t%.15f\t%+.15e\t\t%+.15e\n',order,f,(f/f_exact-1),f-f_exact);
[f]=sec_BackwardSum(x,order);
fprintf('g) \t%d\t%.15f\t%+.15e\t\t%+.15e\n',order,f,(f/f_exact-1),f-f_exact);

%%
end

%% Compute Y_2k from previous ones with recursive formula
function V_y=Next_Y2k(V_y,k)

i=1;
V_y(k+1)=0;
n=2*k;

while i<=k
    V_y(k+1)=V_y(k+1)-nchoosek(n,2*i)*(-1)^i*V_y(k-i+1);
    %C = nchoosek(n,k) where n and k are nonnegative integers, returns
    %n!/((n?k)! k!). This is the number of combinations of n things taken k at a time.

    % Note it is much better to compute nchoosek with a recursive
    % approach but here we simplify our work.
    i=i+1;
end
end

%% Compute all coefficients from 0 to n_max
function [V_y,Order,T_c]=All_Y2k(n_max)
k=0;
V_y(1)=1; % V_y(k)=Derivative of  2*(k-1) order
while (2*k)<n_max
    V_y=Next_Y2k(V_y,k+1);
    k=k+1;
end
if nargout>1
    Order=2*[0:length(V_y)-1];
    T_c=V_y./factorial(Order); % Taylor Coefficiet T_y(k)=V_y(k)/factorial(2*(k-1));
end
end

%% Compute sec(x) by a forward Summation
function [f,order]=sec_ForwardSum(x,Term_Abs_Limit,Sum_Abs_Limit,Do_Single)
if nargin<4
    Do_Single=0;
end
k=0;
V_y(1)=1; % Derivative of  2*(k-1) order
x_2k=1;
fact=1;

New_Term=inf;

f=0;    % Series value
fp=0;   % Series value up to previous term

if Do_Single
    x_2k=single(x_2k);fact=single(fact);
    New_Term=single(New_Term);
    f=single(f);fp=single(fp);
end

while New_Term>Term_Abs_Limit & (k==0 | (f-fp)>Sum_Abs_Limit)

    New_Term=V_y(end)*x_2k/fact;
    fp=f; 
    f=f+New_Term;
    
    V_y=Next_Y2k(V_y,k+1);    
     
    x_2k=x_2k*x^2;
    fact=fact*(2*k+1)*(2*k+2);    
    k=k+1;
end
f=f+V_y(end)*x_2k/fact;
order=2*k;
end

%% Compute sec(x) by a Backward Summation
function [f]=sec_BackwardSum(x,n_max)


% Forward Compuation of Coefficients
[V_y]=All_Y2k(n_max);
fact=1;
x_2k=1;

x_2k_array=ones(size(V_y));
fact_array=ones(size(V_y));

f=0;    % Series value
for k=0:n_max/2
    x_2k_array(k+1)=x_2k;
    fact_array(k+1)=fact;
    x_2k=x_2k*x^2;
    fact=fact*(2*k+1)*(2*k+2);
end

% Backward Summation
for k=(n_max/2):-1:0
    f=f+x_2k_array(k+1)/fact_array(k+1)*V_y(k+1);
end

end


%% Compute sec(x) by a forward Summation
function [f,order]=sec_Inverse_COS(x,Term_Abs_Limit,Sum_Abs_Limit)

k=0;
x_2k=1; %Includes the sign of cos Taylor's expansion
fact=1;

New_Term=inf;

f=0;    % Series value
fp=0;   % Series value up to previous term

while abs(New_Term)>Term_Abs_Limit & (k==0 | abs(f-fp)>Sum_Abs_Limit)

    New_Term=x_2k/fact;
    fp=f; 
    f=f+New_Term;
     
    x_2k=-x_2k*x^2;
    fact=fact*(2*k+1)*(2*k+2);    
    k=k+1;
end
f=1/(f+x_2k/fact);
order=2*k;
end
