%function  C2p29_PSET1_4p19
%%
% ********************************************************************
% Course Homework
%               2.29: Numerical Fluid Mechanincs, Spring 2007
% Problem Set #1, Problem #1, Textbook Problem 4.19
% 02/12/07
% ********************************************************************
% Reza Karimi:
%                            Graduate Student
%                    Mechanical Engineering Department
%                  Massachusetts Institute of Technology
% Email:  rkarimi@mit.edu
% Office: NE47-319, 500 Technology Square, Cambridge, MA 02139
% Phone: (617) 324-7605
% ********************************************************************


%%
close all,clear all,clc
format short

%% 
h=2;
x=[-2:h:2];

f=x.^3-2*x+4;
df_a=3*x.^2-2;
ddf_a=6*x;

df_cen=[NaN (f(3:end)-f(1:end-2))/(2*h) NaN];
df_for=[(f(2:end)-f(1:end-1))/h NaN];
df_bak=[NaN (f(2:end)-f(1:end-1))/h];

ddf_cen=[NaN (f(3:end)+f(1:end-2)-2*f(2:end-1))/(h^2) NaN];
ddf_for=[(f(3:end)+f(1:end-2)-2*f(2:end-1))/(h^2) NaN NaN];
ddf_bak=[NaN NaN (f(3:end)+f(1:end-2)-2*f(2:end-1))/(h^2) ];

%%
FN_Size_A=16;
FN_Size_T=14;

subplot(2,1,1)
plot(x,df_a,'-b',x,df_cen,'-.*r',x,df_for,'--+r',x,df_bak,'-.sg')
legend('Analytical','Central','Forward','Backward')

hold on, box on, grid on,set(gca,'fontsize',14)
xlabel('x','Interpreter','latex','fontsize',FN_Size_A,...
    'FontAngle','italic','FontWeight','bold','FontName','Times New Roman')
ylabel('$\frac{df}{dx}$','Interpreter','latex','fontsize',FN_Size_A,'FontAngle','italic','FontWeight','bold','FontName','Times New Roman')
title (['Problem 4.19 of Textbook: First Derivative '],'Interpreter','latex',...
    'fontsize',FN_Size_T,'FontAngle','italic','FontWeight','bold','FontName','Times New Roman')

subplot(2,1,2)
plot(x,ddf_a,'-b',x,ddf_cen,'-.*r',x,ddf_for,'--+r',x,ddf_bak,'-.sg')
legend('Analytical','Central','Forward','Backward')

hold on, box on, grid on,set(gca,'fontsize',14)
xlabel('x','Interpreter','latex','fontsize',FN_Size_A,...
    'FontAngle','italic','FontWeight','bold','FontName','Times New Roman')
ylabel('$\frac{df^2}{d^2x}$','Interpreter','latex','fontsize',FN_Size_A,'FontAngle','italic','FontWeight','bold','FontName','Times New Roman')
title (['Problem 4.19 of Textbook: Second Derivative '],'Interpreter','latex',...
    'fontsize',FN_Size_T,'FontAngle','italic','FontWeight','bold','FontName','Times New Roman')

%legend('\sigma_{rr}','\sigma_{\theta\theta}','\sigma_{Mises}','Location','Southwest')

set(gcf,'PaperType','usLetter','PaperOrientation','portrait','PaperUnits','Centimeters','PaperPosition',[1 1 20 18])
set(gcf,'Position',[50 50 [20 18]*40],'color','w')

